/*  Simple template class for quaternions
 *  This is a small demo app
 *  Copyright (C) R. Bourquin, 2008
 *  License: GNU GPL v2.0 or above
 */

#include <iostream>
#include <cstring>
#include <cmath>
#include "quaternion.hh"

int main() {
    std::cout << "-- Simple rotation in R^3 with Quaternions --\n";
    std::cout << "Enter point to rotate:\n";
    double x, y, z;
    std::cin >> x;
    std::cin >> y;
    std::cin >> z;
    std::cout << "Enter rotation axis:\n";
    double u, v, w;
    std::cin >> u;
    std::cin >> v;
    std::cin >> w;
    std::cout << "Enter rotation angle:\n";
    double a;
    std::cin >> a;
    std::cout << "Rotation of Point [" <<x<< ", " <<y<< ", " <<z<< "] around [" <<u<< ", " <<v<< ", " <<w<< "] with angle " <<a<< "°\n";

    double len = sqrt(u*u+v*v+w*w);
    a = a*3.1415926535/180.0;

    // Rotation by Quaternions:
    Quaternion<double> Q = Quaternion<double>(cos(a/2), u/len*sin(a/2),  v/len*sin(a/2),  w/len*sin(a/2));
    Quaternion<double> V = Quaternion<double>(0, x, y, z);
    Quaternion<double> R = Q*V*inverse(Q);

    std::cout << "Resulting point: [" <<R.get_u()<< ", " <<R.get_v()<< ", " <<R.get_w()<< "]\n";
    return 0;
}
